SuperStrict

Framework brl.basic
Import brl.eventqueue
Import maxgui.drivers
Import maxgui.proxygadgets
Import maxgui.xpmanifest
Import brl.glmax2d
Import brl.jpgloader
Import brl.pngloader
Import brl.tgaloader
Import brl.bmploader

GLShareContexts()

Local app:TApp = New TApp.Create(AppArgs)
app.run()

Type TApp
	
	Field stop:Int
	
	Field window:TGadget
	
	Field cmdInput:TGadget
	
	Field cmdOutput:TGadget
	
	Field comboInput:TGadget
	
	Field comboOutput:TGadget
	
	Field canInput:TGadget
	
	Field canOutput:TGadget
	
	Field sliderShift:TGadget
	
	Field sliderDifferential:TGadget
	
	Field tfShift:TGadget
	
	Field tfDifferential:TGadget
	
	Field cmdResetShift:TGadget
	
	Field cmdResetDifferential:TGadget
	
	Field inputImage:TImage
	
	Field inputHeightData:THeightData
	
	Field outputImage:TImage
	
	Field cmdAbout:TGadget
	
	Field mousePosition:TMovement
	
	Method Create:TApp(args:String[])
		Self.window = CreateWindow("Bumpmap Manager", 0, 0, 900, 540,, WINDOW_CENTER | WINDOW_CLIENTCOORDS | WINDOW_RESIZABLE | WINDOW_TITLEBAR | WINDOW_ACCEPTFILES)
		Self.window.SetMinimumSize(580, 400)
		
		Local panelInput:TGadget = CreatePanel(5, 5, 390, 390, Self.window, PANEL_GROUP, "Input")
		panelInput.SetLayout(1, 2, 1, 1)
		
		Local panelOutput:TGadget = CreatePanel(505, 5, 390, 390, Self.window, PANEL_GROUP, "Output")
		panelOutput.SetLayout(2, 1, 1, 1)
		
		Local panelSettings:TGadget = CreatePanel(5, 400, 890, 135, Self.window, panel_group, "Settings")
		panelSettings.SetLayout(1, 1, 0, 1)
		
		Local labelArrow:TGadget = CreateLabel(">", 400, 150, 100, 100, Self.window, LABEL_CENTER)
		labelArrow.SetFont(LookupGuiFont(GUIFONT_SYSTEM, 40))
		labelArrow.SetLayout(2, 2, 2, 2)
		
		Local cw:Int = panelInput.ClientWidth()
		Local ch:Int = panelInput.ClientHeight()
		
		Self.cmdInput = CreateButton("Load image", 0, ch - 30, cw - 100, 30, panelInput)
		Self.cmdInput.SetTooltip("Opens a file explorer to select an image to open.")
		Self.cmdInput.SetLayout(1, 1, 0, 1)
		
		Self.comboInput = CreateComboBox(cw - 100, ch - 30, 100, 30, panelInput)
		Self.comboInput.SetTooltip("Bumpmap interpretation for the input image.")
		Self.comboInput.SetLayout(0, 1, 0, 1)
		Self.comboInput.InsertItem(0, "Normal map", "", -1, EBumpMap.NORMALMAP, 0)
		Self.comboInput.InsertItem(1, "Height map", "", -1, EBumpMap.HEIGHTMAP, 0)
		Self.comboInput.SetEnabled(False)
		
		Self.cmdOutput = CreateButton("Export image", 0, ch - 30, cw - 100, 30, panelOutput)
		Self.cmdOutput.SetTooltip("Opens a file explorer to select the file in which the output image should be saved.")
		Self.cmdOutput.SetLayout(1, 1, 0, 1)
		Self.cmdOutput.SetEnabled(False)
		
		Self.comboOutput = CreateComboBox(cw - 100, ch - 30, 100, 30, panelOutput)
		Self.comboOutput.SetTooltip("Bumpmap interpretation for the output image.")
		Self.comboOutput.SetLayout(0, 1, 0, 1)
		Self.comboOutput.InsertItem(0, "Normal map", "", -1, EBumpMap.NORMALMAP, 0)
		Self.comboOutput.InsertItem(1, "Height map", "", -1, EBumpMap.HEIGHTMAP, 0)
		Self.comboOutput.SetEnabled(False)
		
		Local movement:TMovement = New TMovement.Create(0, 0)
		
		Self.canInput = CreateCanvas(0, 0, cw, ch - 30, panelInput)
		Self.canInput.SetLayout(1, 1, 1, 1)
		Self.canInput.context = movement
		
		Self.canOutput = CreateCanvas(0, 0, cw, ch - 30, panelOutput)
		Self.canOutput.SetLayout(1, 1, 1, 1)
		Self.canOutput.context = movement
		
		CreateLabel("Shift:", 5, 5, 200, 20, panelSettings).SetLayout(1, 0, 1, 0)
		Self.sliderShift = CreateSlider(5, 30, 300, 20, panelSettings, SLIDER_TRACKBAR | SLIDER_HORIZONTAL)
		Self.sliderShift.SetTooltip("Shifting that should be used for the height data (influences only heightmaps).")
		Self.sliderShift.SetLayout(1, 0, 1, 0)
		SetSliderRange(Self.sliderShift, -20, 20)
		SetSliderValue(Self.sliderShift, 0)
		
		CreateLabel("Differential:", 5, 55, 200, 20, panelSettings).SetLayout(1, 0, 1, 0)
		Self.sliderDifferential = CreateSlider(5, 80, 300, 20, panelSettings, SLIDER_TRACKBAR | SLIDER_HORIZONTAL)
		Self.sliderDifferential.SetTooltip("Differential is a multiplier for height data of a bumpmap.")
		Self.sliderDifferential.SetLayout(1, 0, 1, 0)
		SetSliderRange(Self.sliderDifferential, -20, 20)
		SetSliderValue(Self.sliderDifferential, 0)
		
		Self.tfShift = CreateTextField(310, 30, 100, 20, panelSettings)
		Self.tfShift.SetTooltip("Manual shift.")
		Self.tfShift.SetLayout(1, 0, 1, 0)
		
		Self.tfDifferential = CreateTextField(310, 80, 100, 20, panelSettings)
		Self.tfDifferential.SetTooltip("Manual differential.")
		Self.tfDifferential.SetLayout(1, 0, 1, 0)
		
		Self.cmdResetShift = CreateButton("Reset", 310, 5, 100, 20, panelSettings)
		Self.cmdResetShift.SetTooltip("Sets shifting to 0.")
		Self.cmdResetShift.SetLayout(1, 0, 1, 0)
		
		Self.cmdResetDifferential = CreateButton("Reset", 310, 55, 100, 20, panelSettings)
		Self.cmdResetDifferential.SetTooltip("Sets differential to 1.")
		Self.cmdResetDifferential.SetLayout(1, 0, 1, 0)
		
		Self.cmdAbout = CreateButton("About", panelSettings.ClientWidth() - 125, 5, 120, 20, panelSettings)
		Self.cmdAbout.SetTooltip("Shows some about text for this wonderful tool.")
		Self.cmdAbout.SetLayout(0, 1, 1, 0)
		
		CreateHyperlink("http://www.flowersoft.info/", panelSettings.ClientWidth() - 125, 30, 120, 20, panelSettings, LABEL_CENTER, "www.flowersoft.info").SetLayout(0, 1, 1, 0)
		
		Self.onEventOnSlider(TEvent.Create(0))
		
		AddHook(EmitEventHook, Self.eventHook, Self)
		
		If args.Length > 1 Then
			Local file:String = args[1]
			file.Replace(Chr(34), "")
			file.Trim()
			Self.onCmdInput(file)
		End If
		
		Return Self
	End Method
	
	Method run()
		Self.stop = False
		While(Not Self.stop)
			WaitEvent()
			Self.onEvent(CurrentEvent)
		Wend
	End Method
	
	Method onEvent(ev:TEvent)
		Select ev.source
			Case Self.window
				Select ev.id
					Case EVENT_WINDOWCLOSE
						Self.onCmdClose()
					Case EVENT_WINDOWACCEPT
						Self.onCmdInput(String(ev.extra))
				End Select
			Case Self.cmdInput
				Self.onCmdInput()
			Case Self.cmdOutput
				Self.onCmdOutput()
			Case Self.comboInput
				If Self.inputImage Then
					Local format:EBumpMap = EBumpMap(Self.comboInput.ItemExtra(Self.comboInput.SelectedItem()))
					Self.inputHeightData = New THeightData.fromBumpMap(Self.inputImage.Lock(0, True, False), format)
				End If
				Self.updateOutputImage()
			Case Self.comboOutput
				Self.updateOutputImage()
			Case Self.canInput
				Self.onEventOnCanvas(Self.canInput, ev, False)
			Case Self.canOutput
				Self.onEventOnCanvas(Self.canOutput, ev, False)
			Case Self.sliderShift, Self.sliderDifferential
				Self.onEventOnSlider(ev)
			Case Self.tfShift, Self.tfDifferential
				Self.updateOutputImage()
			Case Self.cmdResetShift
				SetSliderValue(Self.sliderShift, 0)
				Self.onEventOnSlider(ev)
			Case Self.cmdResetDifferential
				SetSliderValue(Self.sliderDifferential, 0)
				Self.onEventOnSlider(ev)
			Case Self.cmdAbout
				Self.onCmdAbout()
			Default
				Select ev.id
					Case EVENT_APPTERMINATE
						Self.onCmdClose()
				End Select
		End Select
	End Method
	
	Method onCmdInput(filePath:String = "")
		If filePath = "" Then
			filePath = RequestFile("", "Image Files:png,jpg,jpeg,bmp,tga,tiff;All Files:*", False, "")
		End If
		If filePath <> "" Then
			Local img:TImage = LoadImage(filePath, 0)
			If img Then
				Self.inputImage = img
				
				Local format:EBumpMap = Self.determineBumpMapFromImage(Self.inputImage)
				Self.inputHeightData = New THeightData.fromBumpMap(img.Lock(0, True, False), format)
				
				Select format
					Case EBumpMap.NORMALMAP
						Self.comboInput.SelectItem(0)
						Self.comboOutput.SelectItem(1)
					Case EBumpMap.HEIGHTMAP
						Self.comboInput.SelectItem(1)
						Self.comboOutput.SelectItem(0)
				End Select
				
				Self.canInput.SetTooltip(filePath)
				
				TMovement(Self.canInput.context).set(0, 0)
				TMovement(Self.canOutput.context).set(0, 0)
				
				Self.comboInput.SetEnabled(True)
				Self.cmdOutput.SetEnabled(True)
				Self.comboOutput.SetEnabled(True)
				RedrawGadget(Self.canInput)
				Self.updateOutputImage()
			Else
				Notify "Could not load file " + filePath + "."
			End If
		End If
	End Method
	
	Method onCmdOutput()
		If Self.outputImage Then
			Local file:String = RequestFile("", "PNG File:png;JPEG File:jpg;All Files:*", True, "")
			If file <> "" Then
				Local pix:TPixmap = Self.outputImage.Lock(0, True, False)
				Local result:Int = False
				Select ExtractExt(file).ToLower()
					Case "jpg", "jpeg"
						result = SavePixmapJPeg(pix, file, 100)
					Default
						result = SavePixmapPNG(pix, file, 9)
				End Select
				If Not result Then
					Notify("Could not save image.")
				End If
			End If
		End If
	End Method
	
	Method onCmdAbout()
		Notify("Bumpmap Manager~nThis nice little tool was created by Lobby Divinus. It's Open Source so do what you want to do with it.~n~nPlease also visit our homepage flowersoft.info")
	End Method
	
	Method onCmdClose()
		Self.stop = True
	End Method
	
	Method onEventOnCanvas(canvas:TGadget, ev:TEvent, paint:Int)
		Local movement:TMovement = TMovement(canvas.context)
		Select ev.id
			Case EVENT_MOUSEENTER
				If Self.inputImage Then
					Local tooWidth:Int = Self.inputImage.width > canvas.ClientWidth()
					Local tooHeight:Int = Self.inputImage.height > canvas.ClientHeight()
					Select True
						Case tooWidth And tooHeight
							SetPointer(POINTER_SIZEALL)
						Case tooWidth
							SetPointer(POINTER_SIZEWE)
						Case tooHeight
							SetPointer(POINTER_SIZENS)
						Default
							SetPointer(POINTER_DEFAULT)
					End Select
				Else
					SetPointer(POINTER_DEFAULT)
				End If
			Case EVENT_MOUSELEAVE
				SetPointer(POINTER_DEFAULT)
			Case EVENT_MOUSEDOWN
				If ev.data = 1 Then
					movement.lock()
					Self.mousePosition = New TMovement.Create(ev.x, ev.y)
				End If
			Case EVENT_MOUSEUP
				If ev.data = 1 Then
					movement.unlock()
				End If
			Case EVENT_MOUSEMOVE
				If movement.isLocked() And Self.mousePosition Then
					movement.setX(movement.getX() + ev.x - Self.mousePosition.getX())
					movement.setY(movement.getY() + ev.y - Self.mousePosition.getY())
					Self.mousePosition.set(ev.x, ev.y)
					Self.drawCanvas(Self.canInput)
					Self.drawCanvas(Self.canOutput)
				End If
			Case EVENT_GADGETPAINT
				If paint Then
					Self.drawCanvas(canvas)
				End If
		End Select
	End Method
	
	Method onEventOnSlider(ev:TEvent)
		Select ev.source
			Case Self.sliderShift
				Local shift:Float = 0.25 * (SliderValue(Self.sliderShift))
				Self.tfShift.SetText(Self.convertFloatToString(shift))
			Case Self.sliderDifferential
				Local differential:Float = Sqr(Sqr(Sqr(2))) ^ (SliderValue(Self.sliderDifferential))
				Self.tfDifferential.SetText(Self.convertFloatToString(differential))
			Default
				Local shift:Float = 0.25 * (SliderValue(Self.sliderShift))
				Local differential:Float = Sqr(Sqr(Sqr(2))) ^ (SliderValue(Self.sliderDifferential))
				Self.tfShift.SetText(Self.convertFloatToString(shift))
				Self.tfDifferential.SetText(Self.convertFloatToString(differential))
		End Select
		Self.updateOutputImage()
	End Method
	
	Method getCurrentShift:Float()
		Return(Float(Self.tfShift.GetText()))
	End Method
	
	Method getCurrentDifferential:Float()
		Return(Float(Self.tfDifferential.GetText()))
	End Method
	
	Method updateOutputImage()
		If Self.inputImage Then
			Local outputFormat:EBumpMap = EBumpMap(Self.comboOutput.ItemExtra(Self.comboOutput.SelectedItem()))
			
			Local shift:Float = Self.getCurrentShift()
			Local differential:Float = Self.getCurrentDifferential()
			
			Local hd:THeightData = Self.inputHeightData.clone()
			hd.useShift(shift)
			hd.useDifferential(differential)
			Local outputPix:TPixmap = hd.toBumpMap(outputFormat)
			
			Self.outputImage = LoadImage(outputPix, 0)
			RedrawGadget(Self.canOutput)
		End If
	End Method
	
	Method drawCanvas(canvas:TGadget)
		SetGraphics(canvas.CanvasGraphics())
		SetViewport(0, 0, canvas.ClientWidth(), canvas.ClientHeight())
		SetAlpha(1)
		SetColor(255, 255, 255)
		SetTransform()
		SetBlend(AlphaBlend)
		
		Local guiR:Byte
		Local guiG:Byte
		Local guiB:Byte
		LookupGuiColor(GUICOLOR_WINDOWBG, guiR, guiG, guiB)
		SetClsColor(guiR, guiG, guiB)
		Cls()
		
		Local movement:TMovement = TMovement(canvas.context)
		
		Local img:TImage
		Select canvas
			Case Self.canInput
				img = Self.inputImage
			Case Self.canOutput
				img = Self.outputImage
		End Select
		
		If img Then
			Local x:Int
			Local y:Int
			If img.width < canvas.ClientWidth() Then
				x = (canvas.ClientWidth() - img.width) / 2
				movement.setX(0)
			Else
				x = movement.getX()
				x = Min(Max(x, canvas.ClientWidth() - img.width), 0)
				movement.setX(x)
			End If
			If img.height < canvas.ClientHeight() Then
				y = (canvas.ClientHeight() - img.height) / 2
				movement.setY(0)
			Else
				y = movement.getY()
				y = Min(Max(y, canvas.ClientHeight() - img.height), 0)
				movement.setY(y)
			End If
			DrawImage(img, x, y)
		End If
		
		Flip()
	End Method
	
	Function eventHook:Object(id:Int, data:Object, context:Object)
		Local ev:TEvent = TEvent(data)
		If ev Then
			Local app:TApp = TApp(context)
			If app Then
				Select ev.source
					Case app.canInput, app.canOutput
						Select ev.id
							Case EVENT_GADGETPAINT
								app.onEventOnCanvas(TGadget(ev.source), ev, True)
								Return Null
						End Select
				End Select
			End If
		End If
		Return data
	End Function
	
	Function determineBumpMapFromImage:EBumpMap(img:TImage)
		Local pix:TPixmap = img.Lock(0, True, False)
		
		Select pix.format
			Case PF_A8, PF_I8, PF_RED, PF_GREEN, PF_BLUE, PF_ALPHA, PF_INTENSITY, PF_LUMINANCE
				Return EBumpMap.HEIGHTMAP
		End Select
		If BytesPerPixel[pix.format] < 3 Then
			Return EBumpMap.HEIGHTMAP
		End If
		
		Local pixels:Byte Ptr = pix.pixels
		Local x:Int
		Local y:Int
		Local pixpos:Int
		Local r:Int
		Local g:Int
		Local b:Int
		
		For y = 0 Until pix.height
			For x = 0 Until pix.width
				pixpos = x * BytesPerPixel[pix.format] + y * pix.pitch
				r = pixels[pixpos]
				g = pixels[pixpos + 1]
				b = pixels[pixpos + 2]
				If r <> g Or r <> b Then
					Return EBumpMap.NORMALMAP
				End If
			Next
		Next
		
		Return EBumpMap.HEIGHTMAP
	End Function
	
	Function convertFloatToString:String(f:Float)
		Local txt:String = f
		If txt.Contains(".") Then
			While(txt.EndsWith("0"))
				txt = txt[..txt.length - 1]
			Wend
			If txt.EndsWith(".") Then
				txt = txt[..txt.length - 1]
			End If
		End If
		Return txt
	End Function
	
End Type

Type THeightData
	
	Field width:Int
	
	Field height:Int
	
	Field data:Float[,]
	
	Field hasNormapMapSource:Int
	
	Field normalData:Float[,,]
	
	Method fromBumpMap:THeightData(pix:TPixmap, format:EBumpMap)
		Select format
			Case EBumpMap.NORMALMAP
				Return Self.fromNormalMap(pix)
			Case EBumpMap.HEIGHTMAP
				Return Self.fromHeightMap(pix)
		End Select
		Return Null
	End Method
	
	Method fromHeightMap:THeightData(pix:TPixmap)
		Self.width = pix.width
		Self.height = pix.height
		Self.data = New Float[pix.width, pix.height]
		Local x:Int
		Local y:Int
		For y = 0 Until pix.height
			For x = 0 Until pix.width
				data[x, y] = pix.pixels[x * BytesPerPixel[pix.format] + y * pix.pitch] / 255.0
			Next
		Next
		Return Self
	End Method
	
	Method fromNormalMap:THeightData(pix:TPixmap)
		Self.width = pix.width
		Self.height = pix.height
		Self.data = New Float[pix.width, pix.height]
		Local x:Int
		Local y:Int
		Local pos:Int
		Local r:Int
		Local g:Int
		Local b:Int
		Local nx:Float
		Local ny:Float
		Local nz:Float
		Local sum:Float
		Local hdat:Float[,,] = New Float[pix.width, pix.height, 4]
		Local cdat:Float[,,] = New Float[pix.width, pix.height, 4]
		Local xmove:Int[] = [0, 1, 1, 0]
		Local ymove:Int[] = [0, 0, 1, 1]
		hdat[0, 0, 0] = 0
		Self.hasNormapMapSource = True
		Self.normalData = New Float[Self.width, Self.height, 3]
		For Local i:Int = 0 Until 4
			hdat[xmove[i] * (pix.width - 1), ymove[i] * (pix.height - 1), i] = hdat[xmove[i] * (pix.width - 1), ymove[i] * (pix.height - 1), 0]
			cdat[xmove[i] * (pix.width - 1), ymove[i] * (pix.height - 1), i] = 1
			y = (pix.height - 1) * ymove[i]
			While(y <> (pix.height - 1) * (1 - ymove[i]))
				x = (pix.width - 1) * xmove[i]
				While(x <> (pix.width - 1) * (1 - xmove[i]))
					pos = x * BytesPerPixel[pix.format] + y * pix.pitch
					r = pix.pixels[pos]
					g = pix.pixels[pos + 1]
					b = pix.pixels[pos + 2]
					nx = r / 127.5 - 1.0
					ny = g / 127.5 - 1.0
					nz = b / 127.5 - 1.0
					If i = 0 Then
						Self.normalData[x, y, 0] = nx
						Self.normalData[x, y, 1] = ny
						Self.normalData[x, y, 2] = nz
					End If
					'sum = nz / 0.1
					'sum = Sqr(nx * nx + ny * ny + nz * nz)
					sum = 2.0
					nx:/sum
					ny:/sum
					nz:/sum
					hdat[x + 1 - 2 * xmove[i], y, i]:+hdat[x, y, i] / cdat[x, y, i] - nx * (1 - 2 * xmove[i])
					cdat[x + 1 - 2 * xmove[i], y, i]:+1
					hdat[x, y + 1 - 2 * ymove[i], i]:+hdat[x, y, i] / cdat[x, y, i] + ny * (1 - 2 * ymove[i])
					cdat[x, y + 1 - 2 * ymove[i], i]:+1
					hdat[x + 1 - 2 * xmove[i], y + 1 - 2 * ymove[i], i]:+0.5 * (hdat[x, y, i] / cdat[x, y, i] - nx * (1 - 2 * xmove[i]) + ny * (1 - 2 * ymove[i]))
					cdat[x + 1 - 2 * xmove[i], y + 1 - 2 * ymove[i], i]:+0.5
					x:+(1 - 2 * xmove[i])
				Wend
				y:+(1 - 2 * ymove[i])
			Wend
		Next
		For y = 0 Until pix.height
			For x = 0 Until pix.width
				sum = 0
				For Local i:Int = 0 Until 4
					sum:+hdat[x, y, i] / cdat[x, y, i]
				Next
				Self.data[x, y] = sum / 4.0
			Next
		Next
		Return Self
	End Method
	
	Method toBumpMap:TPixmap(format:EBumpMap)
		Select format
			Case EBumpMap.NORMALMAP
				Return Self.toNormalMap()
			Case EBumpMap.HEIGHTMAP
				Return Self.toHeightMap()
		End Select
		Return Null
	End Method
	
	Method toHeightMap:TPixmap()
		Local pix:TPixmap = TPixmap.Create(Self.width, Self.height, PF_I8)
		Local x:Int
		Local y:Int
		For y = 0 Until Self.height
			For x = 0 Until Self.width
				pix.pixels[x + y * pix.pitch] = Min(Max(255 * Self.data[x, y], 0), 255)
			Next
		Next
		Return pix
	End Method
	
	Method toNormalMap:TPixmap()
		Local pix:TPixmap = TPixmap.Create(Self.width, Self.height, PF_RGB)
		Local x:Int
		Local y:Int
		Local nx:Float
		Local ny:Float
		Local nz:Float
		Local sum:Float
		Local pos:Int
		Local r:Float
		Local g:Float
		Local b:Float
		Local rdat:Int[,] = New Int[Self.width, Self.height]
		Local gdat:Int[,] = New Int[Self.width, Self.height]
		Local bdat:Int[,] = New Int[Self.width, Self.height]
		Local cdat:Int[,] = New Int[Self.width, Self.height]
		Local xmove:Int[] = [0, 1, 0, 1]
		Local ymove:Int[] = [0, 0, 1, 1]
		If Self.hasNormapMapSource Then
			For y = 0 Until Self.height
				For x = 0 Until Self.width
					nx = Self.normalData[x, y, 0]
					ny = Self.normalData[x, y, 1]
					nz = Self.normalData[x, y, 2]
					sum = Sqr(nx * nx + ny * ny + nz * nz)
					nx:/sum
					ny:/sum
					nz:/sum
					r = (nx + 1.0) * 127.5
					g = (ny + 1.0) * 127.5
					b = (nz + 1.0) * 127.5
					rdat[x, y]:+r
					gdat[x, y]:+g
					bdat[x, y]:+b
					cdat[x, y]:+1
				Next
			Next
		Else
			For Local i:Int = 0 Until 4
				For y = ymove[i] Until Self.height - 1 + ymove[i]
					For x = xmove[i] Until Self.width - 1 + xmove[i]
						nx = Self.data[x - xmove[i], y] - Self.data[x + 1 - xmove[i], y]
						ny = Self.data[x, y + 1 - ymove[i]] - Self.data[x, y - ymove[i]]
						nz = 0.1
						sum = Sqr(nx * nx + ny * ny + nz * nz)
						nx:/sum
						ny:/sum
						nz:/sum
						r = (nx + 1.0) * 127.5
						g = (ny + 1.0) * 127.5
						b = (nz + 1.0) * 127.5
						rdat[x, y]:+r
						gdat[x, y]:+g
						bdat[x, y]:+b
						cdat[x, y]:+1
					Next
				Next
			Next
		End If
		For y = 0 Until Self.height
			For x = 0 Until Self.width
				r = rdat[x, y] / cdat[x, y]
				g = gdat[x, y] / cdat[x, y]
				b = bdat[x, y] / cdat[x, y]
				r = Min(Max(r, 0), 255)
				g = Min(Max(g, 0), 255)
				b = Min(Max(b, 0), 255)
				pos = x * 3 + y * pix.pitch
				pix.pixels[pos] = r
				pix.pixels[pos + 1] = g
				pix.pixels[pos + 2] = b
			Next
		Next
		Return pix
	End Method
	
	Method useShift(shift:Float)
		Local x:Int
		Local y:Int
		For y = 0 Until Self.height
			For x = 0 Until Self.width
				Self.data[x, y]:+shift
			Next
		Next
	End Method
	
	Method useDifferential(diff:Float)
		Local x:Int
		Local y:Int
		For y = 0 Until Self.height
			For x = 0 Until Self.width
				Self.data[x, y]:*diff
			Next
		Next
		If Self.hasNormapMapSource Then
			For y = 0 Until Self.height
				For x = 0 Until Self.width
					Self.normalData[x, y, 0]:*diff
					Self.normalData[x, y, 1]:*diff
				Next
			Next
		End If
	End Method
	
	Method clone:THeightData()
		Local h:THeightData = New THeightData
		h.width = Self.width
		h.height = Self.height
		h.data = New Float[Self.width, Self.height]
		For Local y:Int = 0 Until Self.height
			For Local x:Int = 0 Until Self.width
				h.data[x, y] = Self.data[x, y]
			Next
		Next
		
		If Self.hasNormapMapSource Then
			h.hasNormapMapSource = True
			h.normalData = New Float[Self.width, Self.height, 3]
			For Local i:Int = 0 Until 3
				For Local y:Int = 0 Until Self.height
					For Local x:Int = 0 Until Self.width
						h.normalData[x, y, i] = Self.normalData[x, y, i]
					Next
				Next
			Next
		End If
		
		Return h
	End Method
	
End Type

Type TMovement
	
	Field x:Int
	
	Field y:Int
	
	Field locked:Int
	
	Method Create:TMovement(x:Int, y:Int)
		Self.x = x
		Self.y = y
		Return Self
	End Method
	
	Method set(x:Int, y:Int)
		Self.x = x
		Self.y = y
	End Method
	
	Method setX(x:Int)
		Self.x = x
	End Method
	
	Method setY(y:Int)
		Self.y = y
	End Method
	
	Method get(x:Int Var, y:Int Var)
		x = Self.x
		y = Self.y
	End Method
	
	Method getX:Int()
		Return x
	End Method
	
	Method getY:Int()
		Return y
	End Method
	
	Method isLocked:Int()
		Return Self.locked
	End Method
	
	Method lock()
		Self.locked = True
	End Method
	
	Method unlock()
		Self.locked = False
	End Method
	
End Type

Type EBumpMap
	
	Global NORMALMAP:EBumpMap = New EBumpMap
	
	Global HEIGHTMAP:EBumpMap = New EBumpMap
	
End Type
